let cryptoJS = require('crypto-js')
let moment = require(`moment`);

let rb = {
    qp: undefined,
    cryptoKey: undefined,
    build: function build(data, message, status, log, option) {
        try {
            option = option || {};
            if (option.byPassEncryption) {

            } else {
                if (rb.cryptoKey) {
                    data = cryptoJS.AES.encrypt(JSON.stringify(data), rb.cryptoKey).toString()
                }
            }

            let response =
            {
                status: status || 200,
                message: message || "",
                data: data || {},
                log: log || ""
            }
            return response;
        } catch (err) {
            return rb.buildError(err);
        }
    },
    buildJson: (json, message, status, log, option) => {
        try {
            option = option || {};
            if (option.byPassEncryption) {

            } else {
                if (rb.cryptoKey) {
                    json = cryptoJS.AES.encrypt(json, rb.cryptoKey).toString()
                }
            }
            let response =
            {
                status: status || 200,
                message: message || "",
                data: json || {},
                log: log || ""
            }
            return response;
        } catch (err) {
            return rb.buildError(err);
        }
    },
    buildError: function buildError(message, status, data, log, accept200) {
        let response = "";
        if (message.status == 200) {
            if (accept200) {

            } else {
                delete message.status;
            }
        }
        if (message instanceof Error) {
            response =
            {
                status: message.status || 500,
                message: message.message || "",
                data: data || {}
            }
        } else {
            response =
            {
                status: status || 500,
                message: message || "",
                data: data || {},
                log: log || ""
            }
        }
        return response;
    },
    buildErrorObject: function buildError(error) {
        console.log(`Deprecated!`);
        let response =
        {
            status: error.status || 500,
            message: error.message || "",
            data: data || {}
        }
        return response;
    },
    presetCryptoKey: function preset(key) {
        rb.cryptoKey = key;
    },
    /**
     * You must await thie method
     * otherParams is optional and designed as an object
     */
    buildTable: async (body, searchQueryWithColon, allQueryWithColon, otherParams, buildOption) => {
        if (!rb.qp)
            rb.qp = require('flexqp');
        let qp = rb.qp;
        let con;
        otherParams = otherParams || {};
        try {
            // if (!searchQueryWithColon.includes(`SQL_CALC_FOUND_ROWS`) || !allQueryWithColon.includes(`SQL_CALC_FOUND_ROWS`)) {
            //     let err = new Error(`SQL_CALC_FOUND_ROWS is required`);
            //     console.log(err);
            //     throw err;
            // }
            if (!searchQueryWithColon.includes(`SQL_CALC_FOUND_ROWS`)) {
                searchQueryWithColon = searchQueryWithColon.replace(/select/i, 'select SQL_CALC_FOUND_ROWS')
            }
            if (!allQueryWithColon.includes(`SQL_CALC_FOUND_ROWS`)) {
                allQueryWithColon = allQueryWithColon.replace(/select/i, 'select SQL_CALC_FOUND_ROWS')
            }
            if (body.search.value) {
                if (!searchQueryWithColon.includes(`:search`)) {
                    let err = new Error(`:search is required in search query`);
                    console.log(err);
                    throw err;
                }
            }

            let searchValue = body.search.value == undefined ? null : body.search.value;
            let rows = Number(body.length || 20);
            let minValue = Number(body.start);

            let sortingArr = [];
            for (const orderBy of body.order) {
                let columnName = body.columns[Number(orderBy.column)].data;
                let order = orderBy.dir; // desc or asc
                const sorting = columnName + ' ' + order + ' ';
                sortingArr.push(sorting);
            }
            sorting = `${sortingArr.toString()}`;
            let limit;
            rows === -1 ? limit = '' : limit = 'limit :minValue, :rows';
            let query = ``; //final query
            let param = {};
            con = await qp.connectWithTbegin();
            if (searchValue) {
                query = `${searchQueryWithColon} order by ${sorting}${limit}`;
                param = { search: searchValue, minValue: minValue, rows: rows };
            } else {
                query = `${allQueryWithColon} order by ${sorting}${limit}`;
                param = { search: searchValue, minValue: minValue, rows: rows }
            }
            let option = {
                sql: query, typeCast: function (field, next) {
                    if (field.type == 'JSON') {
                        return JSON.parse(field.string());
                    }
                    if (field.type == 'TIMESTAMP') {
                        let str = field.string();
                        if (str != null)
                            return moment(str).format('YYYY-MM-DD HH:mm:ss');
                        else
                            return str;
                    }
                    return next();
                }
            };
            param = Object.assign(otherParams, param)
            let result = await qp.executeWithOptions(option, param, con);
            let count = await qp.execute(`select found_rows() as totalCount;`, [], con);
            count = count[0];
            let data = { draw: body.draw, recordsTotal: count.totalCount, recordsFiltered: count.totalCount, data: result };
            await qp.commitAndCloseConnection(con);
            return rb.build(data, `Success!`, null, null, buildOption);
        } catch (err) {
            await qp.rollbackAndCloseConnection(con);
            console.log(`only qp version 2.2.1 and above is supported !`)
            throw err;
        }
    },
    setQpDriver: (qp) => {
        rb.qp = qp || require('flexqp');
    }
}



module.exports = rb;